<style lang="scss">
@import "~bootstrap/scss/bootstrap.scss";
</style>

<template>
  <div id="app" class="m-2">
    <div class="modal-backdrop show"></div>
    <div class="modal" style="display: block; overflow-y: scroll;">
      <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Register to sessions</h5>
          </div>
          <div class="modal-body">
            <app-form
              v-model="value"
              :participants="participants"
              :room-options="roomOptions"
              :date-options="dateOptions"
              :session-options="sessionOptions"
            />
          </div>
          <div class="modal-footer">
            <div class="row form-inline flex-grow-1 text-left">
              <div class="col-auto">
                <div class="custom-control custom-checkbox">
                  <input
                    type="checkbox"
                    class="custom-control-input"
                    id="customCheck1"
                    v-model="value.sendEmail"
                  />
                  <label class="custom-control-label" for="customCheck1"
                    >Send email</label
                  >
                </div>
              </div>
              <div class="col">
                <select
                  class="custom-select form-control"
                  readonly
                  :disabled="!value.sendEmail"
                >
                  <option selected>noreply@myhybridlab.lsmu.lt</option>
                </select>
              </div>
              <div class="col-auto">
                <button class="btn btn-primary">Submit</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AppForm from "./form";
import { eachDayOfInterval, parseISO, lightFormat } from "date-fns";
export default {
  name: "app",
  components: { AppForm },
  data() {
    return {
      participants: 2,
      roomOptions: Array.from({ length: 20 }, (x, i) => ({
        id: i + 0,
        name: `#HL${(i + 1).toString().padStart(2, "0")}`
      })),
      dateOptions: eachDayOfInterval({
        start: parseISO("2019-09-10"),
        end: parseISO("2019-10-20")
      })
        .map(x => lightFormat(x, "yyyy-MM-dd"))
        .filter(x => !["2019-09-15"].includes(x)),
      sessionOptions: [],

      value: {
        rooms: [1],
        dates: ["2019-09-10"],
        sessions: [],
        sendEmail: false
      }
    };
  },
  computed: {
    roomsAndDates() {
      return `${this.value.rooms.join(",")} ${this.value.dates.join(",")}`;
    }
  },
  watch: {
    roomsAndDates: {
      immediate: true,
      handler() {
        let id = 0;
        const sessions = [];
        this.value.dates.forEach(date => {
          this.value.rooms.forEach(room_id => {
            Array.from({ length: 24 }, (x, i) => i).forEach(i => {
              sessions.push({
                id: ++id,
                room_id,
                date,
                start: `${date}T${(0 + i).toString().padStart(2, "0")}:00:00`,
                end: `${date}T${(1 + i).toString().padStart(2, "0")}:00:00`,
                registration: {
                  max: 3,
                  current: i > 8 && i < 18 ? (id - 1) % 4 : 0
                }
              });
            });
          });
        });
        this.sessionOptions = sessions;
        this.value.sessions = this.value.sessions.filter(session => {
          return sessions.map(x => x.id).includes(session);
        });
      }
    }
  }
};
</script>
